#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    enum ScreenOrientation {
        ScreenOrientationLockPortrait,
        ScreenOrientationLockLandscape,
        ScreenOrientationAuto
    };

    explicit MainWindow(QWidget *parent = 0);
    virtual ~MainWindow();

    // Note that this will only have an effect on Symbian and Fremantle.
    void setOrientation(ScreenOrientation orientation);

    void showExpanded();

public slots:
    void reorderUI();
    void insertChar(QString character);
    void on_btn_0_pressed();
    void on_btn_1_pressed();
    void on_btn_2_pressed();
    void on_btn_3_pressed();
    void on_btn_4_pressed();
    void on_btn_5_pressed();
    void on_btn_6_pressed();
    void on_btn_7_pressed();
    void on_btn_8_pressed();
    void on_btn_9_pressed();
    void on_btn_A_pressed();
    void on_btn_B_pressed();
    void on_btn_C_pressed();
    void on_btn_D_pressed();
    void on_btn_E_pressed();
    void on_btn_F_pressed();
    void on_btnClear_pressed();
    void on_btnBack_pressed();



private slots:
    void on_btnGetOrg_pressed();

private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
